<template>
  <main>
    <div class="px-0 pt-4 pb-20">
      <div class="w-full max-w-full px-8 py-0 m-auto my-0">
        <div class="relative flex flex-wrap items-center justify-between mb-6">
          <h1
            class="text-2xl w-auto m-0 font-bold text-[var(--title-font-color)]"
          >
            {{ $t("account") }}
          </h1>
          <div class="text-2xl text-[#b3b6bc]" @click="onLogout">
            <img
              class=""
              :src="
                getAssetImage(
                  'assets/theme/black_modern_1/images/profileMenu/sign-out.svg'
                )
              "
              alt=""
            />
          </div>
        </div>
        <div class="grid w-full grid-cols-1 gap-5">
          <div class="">
            <div
              class="flex mb-6 p-0 w-full bg-[var(--background-body)] rounded-2xl"
            >
              <div class="flex-shrink-0">
                <div
                  class="w-[60px] h-[60px] border-[var(--element-border-color)] border-[2px] box-shadow-inset rounded-[40px] relative"
                >
                  <img
                    class="w-full h-full object-scale-down rounded-[50%]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/avatar.svg'
                      )
                    "
                    alt=""
                  />
                </div>
              </div>
              <div class="flex flex-col justify-center w-full ml-4">
                <div
                  class="font-bold text-2xl mb-1 text-[var(--title-font-color)] items-center"
                >
                  {{ username }}
                </div>
                <div
                  class="text-xs leading-[18px] flex items-center text-[#707585] uppercase"
                >
                  {{ currency }}
                </div>
              </div>
            </div>
            <div
              v-if="isShowDepositWithdrawal && isCashPlayer"
              class="mb-6 p-0 w-full flex flex-col justify-between rounded-2xl bg-[var(--background-body)]"
            >
              <div
                class="flex justify-between mb-6 pb-6 border-[var(--border-color)] border-b-[1px]"
              >
                <nuxt-link
                  to="/deposit"
                  class="w-[calc(50%-6px)] mr-0 border-[var(--element-border-color)] border-[2px] box-border text-[#fff] box-shadow uppercase profile-info__buttons"
                >
                  <span>{{ $t(`deposit${isBhinbhin}`) }}</span>
                </nuxt-link>
                <nuxt-link
                  to="/withdrawal"
                  class="w-[calc(50%-6px)] mr-0 border-[var(--element-border-color)] border-[2px] box-border text-[#707585] box-shadow uppercase profile-info__buttons_1"
                >
                  <span>{{ $t("withdrawal") }}</span>
                </nuxt-link>
              </div>
            </div>
            <div class="flex items-center justify-between w-full mb-6">
              <div
                class="text-sm w-full leading-[1.5] bg-[var(--background-body)] box-shadow rounded-xl"
              >
                <el-collapse v-model="activeNames" accordion>
                  <div class="">
                    <div class="">
                      <el-collapse-item name="balance">
                        <template #title>
                          <div
                            class="pl-4 text-base leading-5 relative flex justify-between items-center min-h-[64px] py-4 pr-[60px] w-full"
                          >
                            <span
                              class="text-base leading-5 font-bold text-[var(--title-font-color)]"
                            >
                              {{ $t("wallet") }}
                            </span>
                            <div
                              class="absolute top-4 right-4 w-8 h-8 rounded-2xl text-[#707585] bg-[var(--button-bg)] box-shadow flex items-center justify-center balance__icon"
                            ></div>
                          </div>
                        </template>
                        <div
                          class="opacity-100 p-4 text-sm box-shadow-inset text-[var(--title-font-color)] rounded-b-xl"
                        >
                          <div class="flex items-center justify-end">
                            <span>
                              {{ $t("refresh") }}
                            </span>
                            <button
                              class="text-[4vw] text-[var(--title-font-color)] ml-2"
                              @click="getBalance"
                            >
                              <icons
                                class="block w-3 h-[14px]"
                                :is-refresh="true"
                              />
                            </button>
                          </div>
                          <div class="bg-[#ccc] my-[5px] w-full h-[1px]"></div>
                          <div
                            v-for="wallet in allWallets"
                            :key="wallet.WalletName"
                          >
                            <div class="flex items-center justify-between pb-1">
                              <span class="text-[var(--title-font-color)]">{{
                                wallet.getWalletNameForDisplay()
                              }}</span>
                              <span class="text-[var(--title-font-color)]">{{
                                wallet.BetCredit
                              }}</span>
                            </div>
                          </div>
                        </div>
                      </el-collapse-item>
                    </div>
                  </div>
                </el-collapse>
              </div>
            </div>
          </div>
          <div class="max-w-full">
            <ul class="flex flex-col items-start justify-start">
              <li
                class="flex items-center justify-between w-full bg-[var(--background-body)] border-[var(--element-border-color)] border-[2px] box-border box-shadow rounded-lg relative mb-4"
              >
                <nuxt-link
                  :to="BET_HISTORY_ROUTES.INDEX"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/bet-history.svg'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("bet_history") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li
                class="flex items-center justify-between w-full bg-[var(--background-body)] border-[var(--element-border-color)] border-[2px] box-border box-shadow rounded-lg relative mb-4"
              >
                <nuxt-link
                  to="/wallet"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/wallet.svg'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("balance") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li
                v-if="referralEnabled && !isV2ReferralEnabled"
                class="flex items-center justify-between w-full bg-[var(--background-body)] border-[var(--element-border-color)] border-[2px] box-border box-shadow rounded-lg relative mb-4"
              >
                <nuxt-link
                  to="/referral"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/referral.png'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("referral") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li
                v-if="isReferralV2Enabled && isShowReferralPage"
                class="flex items-center justify-between w-full bg-[var(--background-body)] border-[var(--element-border-color)] border-[2px] box-border box-shadow rounded-lg relative mb-4"
              >
                <nuxt-link
                  to="/referral-v2/information"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/referral.png'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("referral") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li
                v-if="!agentCooperation.IsHidden"
                class="flex items-center justify-between w-full bg-[var(--background-body)] border-[var(--element-border-color)] border-[2px] box-border box-shadow rounded-lg relative mb-4"
              >
                <nuxt-link
                  to="/agent-cooperation"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/agent.svg'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("agent_cooperation") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li
                class="flex items-center justify-between w-full bg-[var(--background-body)] border-[var(--element-border-color)] border-[2px] box-border box-shadow rounded-lg relative mb-4"
              >
                <nuxt-link
                  to="/messages"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <SvgIcon
                    svg-name="message"
                    class="w-6 h-6 mr-[10px]"
                  ></SvgIcon>
                  <span class="">{{ $t("messages") }}</span>
                  <MessagesMessageCount
                    v-if="unreadInfo && unreadInfo.TotalCount"
                    :count="unreadInfo.TotalCount"
                    :is-unread="true"
                    class="!ml-2"
                  ></MessagesMessageCount>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li
                class="flex items-center justify-between w-full bg-[var(--background-body)] border-[var(--element-border-color)] border-[2px] box-border box-shadow rounded-lg relative mb-4"
              >
                <nuxt-link
                  :to="ROUTES.ACCOUNT.INFO"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/profile_icon.png'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("profile") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
            </ul>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script lang="ts" setup>
import { useHeaderComponent } from "@/composables/useTheme";
import useBalanceInfo from "@/composables/useBalanceInfo";
import commonHelper from "@/utils/commonHelper";
import useMenu from "@/composables/useMenu";
import { Wallet } from "~~/models/common/wallet";
import { store } from "~~/store";

const { $t } = useNuxtApp();
const activeNames = ref([]);
// const authentication = computed(() => store.state.auth);
const username = computed(() =>
  store.state.auth ? store.state.username : $t("anonymous_user")
);
const { logout, referralEnabled, agentCooperation, isReferralV2Enabled } = useHeaderComponent();
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const onLogout = () => {
  logout();
};
const { getBalance, currency, wallets } = useBalanceInfo();
const isBSI = computed(() => !store.state.auth);
const onNavigateToPage = (url: string) => {
  if (isBSI.value) {
    navigateTo("/login");
  } else {
    window.open(url, "_blank");
  }
};
const { getAssetImage, isBhinbhin } = commonHelper;
const { isShowDepositWithdrawal, isCashPlayer } = useMenu();
const allWallets = computed(() => wallets.value.map((w) => new Wallet(w)));
const { fetchMessages, unreadInfo } = useMessage();
const route = useRoute();
onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});
</script>

<style lang="scss" scoped>
.el-collapse {
  --el-collapse-content-bg-color: none;
  --el-collapse-header-bg-color: none;
  border: none;
  :deep(.el-collapse-item__arrow) {
    font-weight: bold;
    color: var(--text);
  }
}
.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 50%;
    object-fit: contain;
  }
  height: 21.83px;
  width: 21.83px;
  border-radius: 50%;
  background-color: rgba(255, 255, 255);
}
</style>
<style lang="scss">
.profile-info__buttons_1 {
  transition: all 0.5s;
  cursor: pointer;
  border-radius: 6px;
  user-select: none;
  padding: 0 20px;
  white-space: nowrap;
  overflow: hidden;
  font-weight: 600;
  text-decoration: none;
  justify-content: center;
  height: 40px;
  font-size: 14px;
  align-items: center;
  display: inline-flex;
  background: var(--button-bg);
}
.profile-info__buttons {
  transition: all 0.5s;
  cursor: pointer;
  border-radius: 6px;
  user-select: none;
  padding: 0 20px;
  white-space: nowrap;
  overflow: hidden;
  font-weight: 600;
  text-decoration: none;
  justify-content: center;
  height: 40px;
  font-size: 14px;
  align-items: center;
  display: inline-flex;
  background: var(--accent-gradient);
}
.el-collapse-item__arrow {
  display: none;
}
.el-collapse-item.is-active .el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: 1px solid var(--border);
}
.el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: unset;
}
.el-collapse-item__header {
  height: 64px;
}
.el-collapse-item__header.is-active .balance__icon {
  transition: transform 0.3s ease-in-out;
}
.el-collapse-item__header.is-active .balance__icon {
  transform: rotate(0deg);
}
.el-collapse-item__header .balance__icon {
  transition: transform 0.3s ease-in-out;
}
.el-collapse-item__header .balance__icon {
  transform: rotate(45deg);
  &::before {
    content: "\00D7";
    font-size: 24px;
  }
}
.el-collapse-item__content {
  padding-bottom: 0;
}
</style>
